package com.hibernate.dao;

import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.criterion.Restrictions;

import com.hibernate.map.Calendario;

public class CalendarioDAO extends Connection{

	public Integer saveCalendario(Calendario calendario){
		int idResult=0;
		try{
			iniciaOperacion();
			idResult = (Integer) sesion.save(calendario);
			tx.commit();
		}catch(HibernateException he){
			manejaExcepcion(he); 
	        throw he;
		}finally{
			sesion.close();
		}
		return idResult;
	}

	public Calendario getCalendario(int idCalendario) {
		Calendario calendario = null;
		try{
			iniciaOperacion(); 
			Criteria criteria = sesion.createCriteria(Calendario.class);
			criteria.add(Restrictions.eq("idCalendario", idCalendario));
			calendario = (Calendario)criteria.uniqueResult(); 
		}catch(HibernateException he){
			manejaExcepcion(he); 
	        throw he; 
		}finally{
			 sesion.close(); 
		}
		return calendario;
	}

	public boolean deleteCalendario(int idCalendario) {
		boolean rc=false;
		try { 
	        iniciaOperacion(); 
	        String hql = "delete from Calendario where idCalendario = "+idCalendario;
            Query query = sesion.createQuery(hql);
            int rowCount = query.executeUpdate();
	        tx.commit();
	        rc=true;
	    }catch(HibernateException he){
			manejaExcepcion(he); 
	        throw he; 
		}finally {
	        sesion.close(); 
	    }  
		return rc;
	}
}
