package com.hibernate.dao;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.criterion.Restrictions;

import com.hibernate.map.Paso;




public class PasoDAO extends Connection{
	
	public boolean insertPaso(Paso paso){
		boolean rc=false;
		try{
			iniciaOperacion();
			sesion.save(paso);
			tx.commit();
			rc=true;
		}catch(HibernateException he){
			manejaExcepcion(he); 
	        throw he;
		}finally{
			sesion.close();
		}
		return rc;
	}
	
	public List<Paso> getPasos(int idTest){
		List<Paso> pasos = null;
		try { 
	        iniciaOperacion(); 
	        Criteria criteria = sesion.createCriteria(Paso.class);
	        criteria.add(Restrictions.eq("idTest", idTest));
	        pasos = criteria.list();
	    }catch(HibernateException he){
			manejaExcepcion(he); 
	        throw he; 
		}finally { 
	        sesion.close(); 
	    }  	
		return pasos;
	}
	
	public boolean deletePasos(List<Paso> pasos){
		boolean rc=false;
		try { 
	        iniciaOperacion(); 
	        for(Paso paso : pasos){
	        	String hql = "delete from Paso where idTest = "+paso.getIdTest();
                Query query = sesion.createQuery(hql);
                int rowCount = query.executeUpdate();
	        }
	        tx.commit();
	        rc=true;
	    }catch(HibernateException he){
			manejaExcepcion(he); 
	        throw he; 
		}finally { 
	        sesion.close(); 
	    }  
		return rc;
	}
	
	public boolean uploadPaso(Paso paso){
		boolean rc=false;
		try{
		    iniciaOperacion(); 
		    sesion.update(paso); 
		    tx.commit(); 
		    rc=true;
		  }catch(HibernateException he){
		    manejaExcepcion(he); 
		    throw he; 
		  }finally{
		    sesion.close(); 
		  }
		return rc;
	}
}
