package com.hibernate.dao;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.criterion.Restrictions;

import com.hibernate.map.RobotTest;

public class RobotTestDAO extends Connection{

	public List<RobotTest> getListRobotTestByIdTest(int idTest){
		List<RobotTest> list = null;
		try{
			iniciaOperacion(); 
			Criteria criteria = sesion.createCriteria(RobotTest.class);
			criteria.add(Restrictions.eq("idTest", idTest));
			list = criteria.list();	
		}catch(HibernateException he){
			manejaExcepcion(he); 
	        throw he; 
		}finally{
			sesion.close(); 
		}
		return list;
	}
	
	
	public List<RobotTest> getListRobotTestByIdRobot(int idRobot){
		List<RobotTest> list = null;
		try{
			iniciaOperacion(); 
			Criteria criteria = sesion.createCriteria(RobotTest.class);
			criteria.add(Restrictions.eq("idRobot", idRobot));
			list = criteria.list();	
		}catch(HibernateException he){
			manejaExcepcion(he); 
	        throw he; 
		}finally{
			sesion.close(); 
		}
		return list;
	}
/**
 * guarda una nueva asignacin de Test a un robot
 * @param listRobotTest
 * @return
 */
	public boolean guardarRobotTest(List<RobotTest> listRobotTest) {
		boolean rc=false;
		try{
			iniciaOperacion();
			Criteria criteria = sesion.createCriteria(RobotTest.class); 
			for(RobotTest robotTest : listRobotTest){
				sesion.save(robotTest);
			}
			tx.commit();
			rc=true;
		}catch(HibernateException he){
			manejaExcepcion(he); 
	        throw he; 
		}finally{
			sesion.close(); 
		}
		return rc;
	}
	
	public boolean deleteRobotTest(int idRobot){
		boolean rc=false;
		try{
			iniciaOperacion(); 
			String hql = "delete from RobotTest where idRobot = "+idRobot;
			Query query = sesion.createQuery(hql);
            query.executeUpdate();
            tx.commit();
 	        rc=true;
		}catch(HibernateException he){
			manejaExcepcion(he); 
	        throw he; 
		}finally { 
	        sesion.close(); 
	    }  
		return rc;
	}
}
