package com.hibernate.dao;

import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.criterion.Restrictions;

import com.hibernate.map.TestCalendario;


public class TestCalendarioDAO extends Connection{
	
	/**
	 * Retorna un TestCalendario dado un identificador de Test
	 * @param idUser
	 * @return
	 */
	public TestCalendario getTestCalendarioByIdTest(int idTest){
		TestCalendario testCalendario = null;
		try{
			iniciaOperacion(); 
			Criteria criteria = sesion.createCriteria(TestCalendario.class);
			criteria.add(Restrictions.eq("idTest", idTest));
			testCalendario = (TestCalendario)criteria.uniqueResult(); 
		}catch(HibernateException he){
			manejaExcepcion(he); 
	        throw he; 
		}finally{
			 sesion.close(); 
		}
		return testCalendario;
	}
	
	public boolean insertTestCalendario(TestCalendario testCalendario){
		boolean rc=false;
		try{
			iniciaOperacion();
			sesion.save(testCalendario);
			tx.commit();
			rc=true;
		}catch(HibernateException he){
			manejaExcepcion(he); 
	        throw he;
		}finally{
			sesion.close();
		}
		return rc;
	}

	public void deleteTestCalendario(int idTest) {
		try { 
	        iniciaOperacion(); 
	        String hql = "delete from TestCalendario where idTest = "+idTest;
            Query query = sesion.createQuery(hql);
            int rowCount = query.executeUpdate();
	        tx.commit();
	    }catch(HibernateException he){
			manejaExcepcion(he); 
	        throw he; 
		}finally {
	        sesion.close(); 
	    }  
	}
}
