package com.servlets;


import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.json.JSONObject;

import com.classes.UserLogin;
import com.hibernate.dao.UsuarioDAO;
import com.hibernate.map.Usuario;

/**
 * 
 * @author Xavier Font Erruz
 *
 */
public class LoginServlet extends HttpServlet{

	private final String LOGON="logon";
	private final String LOGOFF="logoff";
	
	

	/**
	 * si nos llega una peticin por GET la redirigimos a POST
	 * @param  HttpServletRequest peticin
	 * @param HttpServletResponse respuesta
	 */
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)throws ServletException, IOException {
		doPost(req, resp);	
	}
	
	

	/**
	 * Peticin post con la funcin de login
	 * @param  HttpServletRequest peticin
	 * @param HttpServletResponse respuesta
	 */
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)throws ServletException, IOException {
		String operation = req.getParameter("operation");
		JSONObject json = new JSONObject();
		
		//Miramos que tipo de peticin nos llega y saltamos a la funcin correspondiete
		if(operation.equals(LOGON)){
			doLogOn(req,json);
		}else if(operation.equals(LOGOFF)){
			doLogOff(req,json);
		}
		
		
		PrintWriter out = resp.getWriter();
		out.print(json);
		out.flush();
		out.close();
	}


	/**
	 * Funcin para realizar el logut
	 * @param req peticin
	 * @param json objeto JSON
	 */
	private void doLogOff(HttpServletRequest req, JSONObject json) {
		HttpSession sesionOk = req.getSession();
		sesionOk.invalidate();
		json.put("rc", "Ok");
	}

	/**
	 * Funcin para realizar el login
	 * @param req peticin
	 * @param json objeto JSON
	 */
	private void doLogOn(HttpServletRequest req, JSONObject json) {
		UsuarioDAO usuarioDAO = new UsuarioDAO();
		UserLogin userLogin = null;
		//recogemos los parametros
		String username = req.getParameter("username");
		String password = req.getParameter("password");
		//realizamos la consulta para ver si el usuario existe en la BBDD, en caso contrario no seguimos
		List<Usuario> listUsers = usuarioDAO.getUserByName(username);
		for(Usuario usuario : listUsers){
			//si el password tambin coincide
			if(usuario.getPassword().equals(password) && usuario.getLogin().equals(username)){
				userLogin = new UserLogin(usuario.getIdUsuario(), username, password);
				break;
			}
		}
		if(userLogin!=null){
			HttpSession sesionOk = req.getSession();		
			sesionOk.setAttribute("userLogin",userLogin);
			json.put("rc", "Ok");
		}else{
			json.put("rc", "Ko");
		}
		
	}
}
