package com.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.json.JSONArray;
import org.json.JSONObject;

import com.classes.UserLogin;
import com.hibernate.dao.RobotDAO;
import com.hibernate.dao.RobotTestDAO;
import com.hibernate.dao.RobotUsuarioDAO;
import com.hibernate.dao.TestDAO;
import com.hibernate.dao.UsuarioDAO;
import com.hibernate.map.Robot;
import com.hibernate.map.RobotTest;
import com.hibernate.map.RobotUsuario;
import com.hibernate.map.Test;
import com.hibernate.map.Usuario;

/**
 * 
 * @author Xavier Font Erruz
 *
 */
public class RobotServlet extends HttpServlet {
	
	private final int IDUSER_ADMIN=	7;
	private static final int SAVE_ROBOT = 1;
	private static final int DELETE_ROBOT = 2;
	private static final int GETLIST_ROBOTS = 3;
	private static final int GET_ROBOT = 4;
	private static final int GET_ROBOTUSERS = 5;
	private static final int SAVE_ROBOTUSERS = 6;
	private static final int SAVE_ROBOTTEST = 7;
	private static final int GET_ROBOTEDIT = 8;
	private static final int UPLOAD_ROBOT = 9;
	private RobotDAO robotDAO = new RobotDAO();

	/**
	 * 	si nos llega una peticin por GET la redirigimos a POST
	 */
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)throws ServletException, IOException {
		doPost(req, resp);
	}

	/**
	 * Peticin POST
	 */
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)throws ServletException, IOException {
		int operacion = Integer.parseInt(req.getParameter("operacion").trim().toString());
		JSONObject json = new JSONObject();
		//miramos que tipo de operacin sobre robot nos llega y saltamos a la funcin correspondiete
		switch(operacion){
		case SAVE_ROBOT:
			json.put("rc", saveRobot(req));
			break;
		case DELETE_ROBOT:
			json.put("rc", deleteRobots(req));
			break;
		case GETLIST_ROBOTS:
			json = getListRobots(req);
			break;
		case GET_ROBOT:
			json = getRobot(req);
			break;
		case GET_ROBOTUSERS:
			json = getRobotUsers(req);
			break;
		case SAVE_ROBOTUSERS:
			json = saveRobotUsers(req);
			break;
		case SAVE_ROBOTTEST:
			json = saveRobotTest(req);
			break;
		case GET_ROBOTEDIT:
			json = getRobotEdit(req);
			break;
		case UPLOAD_ROBOT:
			json = uploadRobotEdit(req);
			break;
		default:
			break;
		}
		
		PrintWriter out = resp.getWriter();
		out.print(json);
		out.flush();
		out.close();
	}

	/**
	 * Funcin para subir el fichero del test en una edicin de un test
	 * @param req 
	 * @return JSONObjet con los datos del robot
	 */
	private JSONObject uploadRobotEdit(HttpServletRequest req) {
		JSONObject json = new JSONObject();
		String idRobot = req.getParameter("idRobot"); 
		String nombre = req.getParameter("nombre");
		String descripcion = req.getParameter("descripcion");
		RobotDAO robotDAO = new RobotDAO();
		String dataAlta = getDataAlta();
		Robot robot = robotDAO.getRobot(Integer.parseInt(idRobot));
		robot.setNombre(nombre);
		robot.setDescripcion(descripcion);
		robot.setDataAlta(dataAlta);
		json.put("rc", robotDAO.uploadRobot(robot));
		return json;
	}

	private JSONObject getRobotEdit(HttpServletRequest req) {
		JSONObject json = new JSONObject();
		String idRobot = req.getParameter("idRobot");
		RobotDAO robotDAO = new RobotDAO();
		Robot robot = robotDAO.getRobot(Integer.parseInt(idRobot));
		json.put("nombre", robot.getNombre());
		json.put("descripcion", robot.getDescripcion());
		return json;
	}

	private JSONObject saveRobotTest(HttpServletRequest req){
		JSONObject json = new JSONObject();
		String idRobot = req.getParameter("idRobot");
		String[] arrayIdTests = req.getParameter("idTests").split(",");
		RobotTestDAO robotTestDAO = new RobotTestDAO();
		if(robotTestDAO.deleteRobotTest(Integer.parseInt(idRobot))){
			if(arrayIdTests.length != 0 && !arrayIdTests[0].equals("")){
				List<RobotTest> listRobotTest = new ArrayList<RobotTest>();
				for(String idTest : arrayIdTests){
					RobotTest robotTest = new RobotTest(Integer.parseInt(idRobot), Integer.parseInt(idTest));
					listRobotTest.add(robotTest);
				}
				json.put("rc", robotTestDAO.guardarRobotTest(listRobotTest));
			}else{
				json.put("rc", "true");
			}
		}
		return json;
	}

	private JSONObject saveRobotUsers(HttpServletRequest req){
		JSONObject json = new JSONObject();
		String idRobot = req.getParameter("idRobot");
		String[] arrayIdUsers = req.getParameter("idUsers").split(",");
		List<String> listIdUsers = Arrays.asList(arrayIdUsers);
		String idUserAdmin = String.valueOf(TestServlet.IDUSER_ADMIN);
		if(!listIdUsers.contains(idUserAdmin)){
			listIdUsers.add(idUserAdmin);
		}
		RobotUsuarioDAO robotUsuarioDAO = new RobotUsuarioDAO();
		if(robotUsuarioDAO.deleteRobotUsuario(Integer.parseInt(idRobot))){
			List<RobotUsuario> listRobotUsuario = new ArrayList<RobotUsuario>();
			for(String idUser : listIdUsers){
				RobotUsuario robotUsuario = new RobotUsuario(Integer.parseInt(idRobot),Integer.parseInt(idUser));
				listRobotUsuario.add(robotUsuario);
			}
			json.put("rc", robotUsuarioDAO.guardaRobotUsuario(listRobotUsuario));
		}
		
		return json;
	}

	private JSONObject getRobot(HttpServletRequest req) {
		JSONObject json = new JSONObject();
		String idRobot = req.getParameter("idRobot");
		Robot robot = robotDAO.getRobot(Integer.parseInt(idRobot));
		RobotTestDAO robotTestDAO = new RobotTestDAO();
		TestDAO testDAO = new TestDAO();
		List<RobotTest> listRobotTest = robotTestDAO.getListRobotTestByIdRobot(robot.getIdRobot());
		ArrayList<Integer> arrayIdTest = new ArrayList<Integer>();
		for(RobotTest robotTest : listRobotTest){
			arrayIdTest.add(robotTest.getIdTest());
		}
		
		List<Test> listTestByRobot = testDAO.getTestsByIdTest(arrayIdTest);
		
		//Json Robot
		JSONArray robotJsonArray = new JSONArray();
		JSONObject js = new JSONObject();
		js.put("id", robot.getIdRobot());
		robotJsonArray.put(js);
		js = new JSONObject();
		js.put("nombre", robot.getNombre());
		robotJsonArray.put(js);
		js = new JSONObject();
		js.put("descripcion", robot.getDescripcion());
		robotJsonArray.put(js);
		js = new JSONObject();
		String data = robot.getDataAlta().substring(6,8)+" / "+robot.getDataAlta().substring(4,6)+" / "+robot.getDataAlta().substring(0, 4);
		js.put("data", data);
		robotJsonArray.put(js);
		js = new JSONObject();
		js.put("estado", robot.getEstado());
		robotJsonArray.put(js);
		json.put("robot", robotJsonArray);
		
		//Json Test
		JSONArray testJsonArray = new JSONArray();
		for(Test test : listTestByRobot){
			JSONObject jsonTest = new JSONObject();
			jsonTest.put(test.getNombre(), test.getIdTest());
			testJsonArray.put(jsonTest);
		}
		json.put("test", testJsonArray);
		
		return json;
	}

	private boolean deleteRobots(HttpServletRequest req) {
		boolean rc=false;
		String[] arrayIdRobots = req.getParameter("idRobots").trim().split(",");
		rc = robotDAO.deleteRobot(arrayIdRobots);
		if(rc){
			RobotUsuarioDAO robotUsuarioDAO = new RobotUsuarioDAO();
			rc = robotUsuarioDAO.deleteRobotUsuario(arrayIdRobots);
		}
		return rc;
	}

	private JSONObject getListRobots(HttpServletRequest req) {
		JSONObject json = new JSONObject();
		HttpSession sesionOk = req.getSession();
		UserLogin usuarioLogin = (UserLogin)sesionOk.getAttribute("userLogin");
		List<Robot> list = robotDAO.getListRobots(usuarioLogin.getIdUser());
		for(Robot robot : list){
			JSONArray array = new JSONArray();
			array.put(robot.getNombre());
			array.put(robot.getDescripcion());
			String data = robot.getDataAlta();
			data = data.substring(6, 8)+"/"+data.substring(4, 6)+"/"+data.substring(0, 4);
			array.put(data);
			array.put(robot.getEstado());
			json.put(String.valueOf(robot.getIdRobot()), array);
		}
		return json;
	}

	private boolean saveRobot(HttpServletRequest req) {
		boolean rc=false;
		HttpSession sesionOk = req.getSession();
		UserLogin usuarioLogin = (UserLogin)sesionOk.getAttribute("userLogin");
		String nombre = req.getParameter("nombre");
		String descripcion = req.getParameter("descripcion");
		String dataAlta = getDataAlta();
		Robot robot = new Robot(nombre,descripcion,dataAlta,0);
		int idRobot = robotDAO.insertRobot(robot);
		if(idRobot!=0){
			RobotUsuarioDAO robotUsuarioDAO = new RobotUsuarioDAO();
			RobotUsuario robotUsuario = new RobotUsuario(idRobot,usuarioLogin.getIdUser());
			rc = robotUsuarioDAO.insertRobotUsuario(robotUsuario);
			if(usuarioLogin.getIdUser()!=IDUSER_ADMIN){
				robotUsuario = new RobotUsuario(idRobot,IDUSER_ADMIN);
				rc = robotUsuarioDAO.insertRobotUsuario(robotUsuario);
			}
		}
		return rc;
	}
	
	private String getDataAlta(){
		String data = null;
		Calendar cal = Calendar.getInstance();
		int dia = cal.get(Calendar.DAY_OF_MONTH);
		int month = cal.get(Calendar.MONTH)+1;
		String dayString;
		String monthString;
		if(dia<10){
			dayString = "0"+dia;
		}else{
			dayString = String.valueOf(dia);
		}
		if(month<10){
			monthString = "0"+month;	
		}else{
			monthString = String.valueOf(month);
		}
		data = cal.get(Calendar.YEAR)+""+monthString+""+dayString+"0000";
		return data;
	}
	
	private JSONObject getRobotUsers(HttpServletRequest req) {
		JSONObject json = new JSONObject();
		String idRobot = req.getParameter("idRobot");
		RobotUsuarioDAO robotUsuarioDAO = new RobotUsuarioDAO();
		List<RobotUsuario> listRobotUsuario = robotUsuarioDAO.getRobotUserByidRobot(Integer.parseInt(idRobot));
		UsuarioDAO usuarioDAO = new UsuarioDAO();
		List<Usuario> listUsuariosAsignados = usuarioDAO.getUserByIdRobot(listRobotUsuario);
		
		//aadimos al json los usuarios asignados al robot
		JSONArray arrayUsersAssigned = new JSONArray();
		for(Usuario usuario : listUsuariosAsignados){
			JSONObject js = new JSONObject();
			js.put(usuario.getLogin(), usuario.getIdUsuario());
			arrayUsersAssigned.put(js);
		}
		json.put("asigned", arrayUsersAssigned);
		
		//aadimos al json los usuarios disponibles no asignados al robot
		List<Usuario> listUsers = usuarioDAO.getListUsers();
		for(Usuario usuarioAsignado : listUsuariosAsignados){
			Usuario user = null;
			for(Usuario usuario : listUsers){
				if(usuario.getIdUsuario() == usuarioAsignado.getIdUsuario()){
					user = usuario;
					break;
				}
			}
			listUsers.remove(user);
		}
		JSONArray arrayUsersNotAssigned = new JSONArray();
		for(Usuario usuario : listUsers){
			JSONObject js = new JSONObject();
			js.put(usuario.getLogin(), usuario.getIdUsuario());
			arrayUsersNotAssigned.put(js);
		}
		json.put("notasigned", arrayUsersNotAssigned);
		return json;
	}
}
