package com.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.json.JSONArray;
import org.json.JSONObject;

import com.classes.UserLogin;
import com.hibernate.dao.CalendarioDAO;
import com.hibernate.dao.PasoDAO;
import com.hibernate.dao.RobotDAO;
import com.hibernate.dao.RobotTestDAO;
import com.hibernate.dao.TestCalendarioDAO;
import com.hibernate.dao.TestDAO;
import com.hibernate.dao.TestUsuarioDAO;
import com.hibernate.dao.UsuarioDAO;
import com.hibernate.map.Calendario;
import com.hibernate.map.Paso;
import com.hibernate.map.Robot;
import com.hibernate.map.RobotTest;
import com.hibernate.map.Test;
import com.hibernate.map.TestCalendario;
import com.hibernate.map.TestUsuario;
import com.hibernate.map.Usuario;


public class TestServlet extends HttpServlet{
	
	protected static final int IDUSER_ADMIN=	7;
	private static final int SAVE_TEST = 1;
	private static final int DELETE_TEST = 2;
	private static final int GETLIST_TEST = 3;
	private static final int GETLIST_TESTNOTASSIGNED = 4;
	private static final int GET_TEST_EDIT = 5;
	private static final int UPLOAD_TEST = 6;
	private static final int GET_TEST = 7;
	private static final int GET_TESTS_BY_ROBOT = 8;
	private static final int GET_USERS_BY_TEST = 9;
	private static final int GET_CALENDARS = 10;
	private static final int SAVE_TESTUSERS = 11;
	private static final int SAVE_CALENDAR = 12;
	private static final int DELETE_CALENDAR = 13;
	
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)throws ServletException, IOException {
		doPost(req, resp);
	}
	
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)throws ServletException, IOException {
		int operacion = Integer.parseInt(req.getParameter("operacion").trim().toString());
		JSONObject json = new JSONObject();
		switch(operacion){
		case SAVE_TEST:
			json.put("rc", saveTest(req));
			break;
		case DELETE_TEST:
			json.put("rc", deleteTest(req));
			break;
		case GETLIST_TEST:
			json = getListTest(req);
			break;
		case GETLIST_TESTNOTASSIGNED:
			json = getListTestNotAssigned(req);
			break;
		case GET_TEST_EDIT:
			json = getTestEdit(req);
			break;
		case UPLOAD_TEST:
			json = uploadTest(req);
			break;
		case GET_TEST:
			json = getTest(req);
			break;
		case GET_TESTS_BY_ROBOT:
			json = getTestsByRobot(req);
			break;	
		case GET_USERS_BY_TEST:
			json = getUsersByTest(req);
			break;	
		case GET_CALENDARS:
			json = getCalendarByTest(req);
			break;
		case SAVE_TESTUSERS:
			json = saveTestUsers(req);
			break;
		case SAVE_CALENDAR:
			json = saveCalendar(req);
			break;
		case DELETE_CALENDAR:
			json = deleteCalendar(req);
			break;
		default:
			break;
		}
		
		PrintWriter out = resp.getWriter();
		out.print(json);
		out.flush();
		out.close();
		
	}
	
	
	private JSONObject deleteCalendar(HttpServletRequest req) {
		JSONObject json = new JSONObject();
		String idTest = req.getParameter("idTest");
		TestCalendarioDAO testCalendarioDAO = new TestCalendarioDAO();
		TestCalendario testCalendar_Old = testCalendarioDAO.getTestCalendarioByIdTest(Integer.parseInt(idTest));
		testCalendarioDAO.deleteTestCalendario(Integer.parseInt(idTest));
		json.put("rc", new CalendarioDAO().deleteCalendario(testCalendar_Old.getIdCalendario()));
		return json;
	}

	/**
	 * Guardar un nuevo calendario
	 * @param req
	 * @return
	 */
	private JSONObject saveCalendar(HttpServletRequest req) {
		JSONObject json = new JSONObject();
		String fechaInicial = req.getParameter("fechaInicial");
		String horaInicial = req.getParameter("horaInicial");
		String fechaFinal = req.getParameter("fechaFinal");
		String horaFinal = req.getParameter("horaFinal");
		String intervalo = req.getParameter("intervalo");
		CalendarioDAO calendarioDAO = new CalendarioDAO();
		fechaInicial = fechaInicial.substring(6, 10)+""+fechaInicial.substring(0, 2)+""+fechaInicial.substring(3, 5);
		horaInicial = horaInicial.substring(0, 2);
		if(horaFinal.equals("") || fechaFinal.equals("")){
			horaFinal = "-1";
			fechaFinal = "000000000000";
		}else{
			fechaFinal = fechaFinal.substring(6, 10)+""+fechaFinal.substring(0, 2)+""+fechaFinal.substring(3, 5);
			horaFinal = horaFinal.substring(0, 2);
		}
		Calendario calendario = new Calendario(fechaInicial,fechaFinal,Integer.parseInt(horaInicial),Integer.parseInt(horaFinal),Integer.parseInt(intervalo));
		TestCalendarioDAO testCalendarioDAO = new TestCalendarioDAO();
		String idTest = req.getParameter("idTest");
		TestCalendario testCalendar_Old = testCalendarioDAO.getTestCalendarioByIdTest(Integer.parseInt(idTest));
		if(testCalendar_Old!=null){
			testCalendarioDAO.deleteTestCalendario(Integer.parseInt(idTest));
			calendarioDAO.deleteCalendario(testCalendar_Old.getIdCalendario());
		}
		int idCalendario = calendarioDAO.saveCalendario(calendario);
		TestCalendario testCalendario = new TestCalendario(idCalendario,Integer.parseInt(idTest));
		json.put("rc", testCalendarioDAO.insertTestCalendario(testCalendario));
		return json;
	}

	/**
	 * Recupera todos los calendarios disponibles por usuario
	 * @param req
	 * @return
	 */
	private JSONObject getCalendarByTest(HttpServletRequest req) {
		JSONObject json = new JSONObject();
		String idTest = req.getParameter("idTest");
		TestCalendarioDAO testCalendarioDAO = new TestCalendarioDAO();
		TestCalendario testCalendario = testCalendarioDAO.getTestCalendarioByIdTest(Integer.parseInt(idTest));
		if(testCalendario != null){
			CalendarioDAO calendarioDAO = new CalendarioDAO();
			Calendario calendario = calendarioDAO.getCalendario(testCalendario.getIdCalendario());
			json.put("hayCalendario", "true");	
			String fechIni = calendario.getStartDate().substring(6, 8)+"/"+calendario.getStartDate().substring(4, 6)+"/"+calendario.getStartDate().substring(0, 4);
			json.put("fechaIni",fechIni);
			if(calendario.getStartHour() == -1){
				json.put("horaIni", " - ");
			}else{
				json.put("horaIni", calendario.getStartHour()+":00");	
			}
			
			if(calendario.getEndDate().equals("000000000000")){
				json.put("fechaFin", "Sin parada");
			}else{
				String fechFin = calendario.getEndDate().substring(6, 8)+"/"+calendario.getEndDate().substring(4, 6)+"/"+calendario.getEndDate().substring(0, 4);
				json.put("fechaFin", fechFin);
			}
			if(calendario.getEndHour() == -1){
				json.put("horaFin", " - ");
			}else{
				json.put("horaFin", calendario.getEndHour()+":00");	
			}
			
			//json.put("intervalo", "Cada "+calendario.getEveryXMinutes()+" min.");
			json.put("intervalo",calendario.getEveryXMinutes());
		}else{
			json.put("hayCalendario", "false");
		}
		
		return json;
	}

	/**
	 * Salva los usuarios asignados al test y devuelve un rc del resultado de la operacin
	 * @param req
	 * @return
	 */
	private JSONObject saveTestUsers(HttpServletRequest req) {
		JSONObject json = new JSONObject();
		String idTest = req.getParameter("idTest");
		String[] arrayIdUsers = req.getParameter("idUsers").split(",");
		List<String> listIdUsers = Arrays.asList(arrayIdUsers);
		String idUserAdmin = String.valueOf(TestServlet.IDUSER_ADMIN);
		if(!listIdUsers.contains(idUserAdmin)){
			listIdUsers.add(idUserAdmin);
		}
		TestUsuarioDAO testUsuarioDAO = new TestUsuarioDAO();
		if(testUsuarioDAO.deleteTestUsuario(idTest)){
			List<TestUsuario> listTestUsuario = new ArrayList<TestUsuario>();
			for(String idUser : listIdUsers){
				TestUsuario testUsuario = new TestUsuario(Integer.parseInt(idUser),Integer.parseInt(idTest));
				listTestUsuario.add(testUsuario);
			}
			json.put("rc", testUsuarioDAO.guardarTestUsuarios(listTestUsuario));
		}
		return json;
	}

	/**
	 * Devuelve un json con los usuarios relacionados con un test, 
	 * dado un idTest
	 * @param req
	 * @return
	 */
	private JSONObject getUsersByTest(HttpServletRequest req) {
		JSONObject json = new JSONObject();
		String idTest = req.getParameter("idTest");
		TestUsuarioDAO testUsuarioDAO = new TestUsuarioDAO();
		UsuarioDAO usuarioDAO = new UsuarioDAO();
		List<TestUsuario> listTestUsuario = testUsuarioDAO.getTestUsuarioByIdTest(Integer.parseInt(idTest));
		JSONArray jsonArrayAsigned = new JSONArray();
		for(TestUsuario testUsuario : listTestUsuario){
			JSONObject js = new JSONObject();
			Usuario usuario = usuarioDAO.getUsuario(testUsuario.getIdUsuario());
			js.put(usuario.getLogin(), usuario.getIdUsuario());
			jsonArrayAsigned.put(js);
		}
		json.putOpt("asigned", jsonArrayAsigned);
		
		//aadimos al json los usuarios disponibles no asignados al robot
		List<Usuario> listUsers = usuarioDAO.getListUsers();
		for(TestUsuario testUsuario : listTestUsuario){
			Usuario user = null;
			for(Usuario usuario : listUsers){
				if(usuario.getIdUsuario() == testUsuario.getIdUsuario()){
					user = usuario;
					break;
				}
			}
			listUsers.remove(user);
		}
		JSONArray arrayUsersNotAssigned = new JSONArray();
		for(Usuario usuario : listUsers){
			JSONObject js = new JSONObject();
			js.put(usuario.getLogin(), usuario.getIdUsuario());
			arrayUsersNotAssigned.put(js);
		}
		json.put("notasigned", arrayUsersNotAssigned);
		return json;
	}

	/**
	 * Devuelvo un json con la lista de tests asociados a un robot
	 * @param req
	 * @return
	 */
	private JSONObject getTestsByRobot(HttpServletRequest req) {
		TestDAO testDAO = new TestDAO();
		RobotTestDAO robotTestDAO = new RobotTestDAO();
		JSONObject json = new JSONObject();
		String idRobot = req.getParameter("idRobot");
		List<RobotTest> listRobotTest = robotTestDAO.getListRobotTestByIdRobot(Integer.parseInt(idRobot));
		ArrayList<Integer> arrayIdTest = new ArrayList<Integer>();
		for(RobotTest robotTest : listRobotTest){
			arrayIdTest.add(robotTest.getIdTest());
		}
		List<Test> listTestByRobot = testDAO.getTestsByIdTest(arrayIdTest);
		for(Test test : listTestByRobot){
			json.put(test.getNombre(), test.getIdTest());
		}
		return json;
	}

	/**
	 * Retorno un json con todos los parametros relacionados con un test para su administracion
	 * @param req
	 * @return
	 */
	private JSONObject getTest(HttpServletRequest req) {
		TestDAO testDAO = new TestDAO();
		TestUsuarioDAO testUsuarioDAO = new TestUsuarioDAO();
		PasoDAO pasoDAO = new PasoDAO();
		RobotDAO robotDAO = new RobotDAO();
		RobotTestDAO robotTestDAO = new RobotTestDAO();
		TestCalendarioDAO testCalendarioDAO = new TestCalendarioDAO();
		
		JSONObject json = new JSONObject();
		String idTest = req.getParameter("idTest");
		//Test
		Test test = testDAO.getTest(Integer.parseInt(idTest));
		json.put("nombre", test.getNombre());
		//Paso
		List<Paso> listPasos = pasoDAO.getPasos(Integer.parseInt(idTest));
		JSONArray jsonArrayPasos = new JSONArray();
		for(Paso paso : listPasos){
			jsonArrayPasos.put(paso.getNombre());
		}
		json.put("pasos", jsonArrayPasos);
		//Robot
		List<RobotTest> listRobotsTest = robotTestDAO.getListRobotTestByIdTest(Integer.parseInt(idTest));
		JSONArray jsonArrayRobots = new JSONArray();
		for(RobotTest robotTest : listRobotsTest){
			Robot robot = robotDAO.getRobot(robotTest.getIdRobot());
			JSONObject js = new JSONObject();
			js.put("id", robot.getIdRobot());
			js.put("nombre", robot.getNombre());
			jsonArrayRobots.put(js);
		}
		json.put("robots", jsonArrayRobots);
		//Calendario
		TestCalendario testCalendario = testCalendarioDAO.getTestCalendarioByIdTest(Integer.parseInt(idTest));
		if(testCalendario!=null){
			json.put("calendario", "si");
		}else{
			json.put("calendario", "no");
		}
		//Usuario
		List<TestUsuario> listTestUsuario = testUsuarioDAO.getTestUsuarioByIdTest(Integer.parseInt(idTest));
		if(listTestUsuario.size() != 0){
			json.put("usuarios", "si");
		}else{
			json.put("usuarios", "no");
		}
		
		return json;
	}
	
	/**
	 * Actualiza un test ya existente junto a todos los pasos que tenga asociados 
	 * @param req
	 * @return
	 */
	private JSONObject uploadTest(HttpServletRequest req) {
		TestDAO testDAO = new TestDAO();
		PasoDAO pasoDAO = new PasoDAO();
		
		JSONObject json = new JSONObject();
		String idTest = req.getParameter("idTest");
		String nombre = req.getParameter("nombre");
		String descripcion = req.getParameter("descripcion");
		String intentos = req.getParameter("intentos");
		String[] arrayNomPasos = req.getParameter("nomPasos").split("/");
		String browser = req.getParameter("browser");
		Test testOld = testDAO.getTest(Integer.parseInt(idTest));
		String testFile = testOld.getTestFile();
		String data = getDataAlta();
		Test testNew = new Test(Integer.parseInt(idTest),nombre,descripcion,data,testFile,Integer.parseInt(intentos),browser);
		boolean rcUpload = testDAO.uploadTest(testNew);
		List<Paso> listPasosOld = pasoDAO.getPasos(Integer.parseInt(idTest));
		pasoDAO.deletePasos(listPasosOld);
		for(int i=0;i<arrayNomPasos.length;i++){
			Paso paso = new Paso((i+1),Integer.parseInt(idTest),arrayNomPasos[i]);
			rcUpload = pasoDAO.insertPaso(paso);	
		}
		json.put("rc", rcUpload);
		return json;
	}
	
	/**
	 * Retorna un json con todos los parametros necesarios para la edicin de un test
	 * @param req
	 * @return
	 */
	private JSONObject getTestEdit(HttpServletRequest req) {
		TestDAO testDAO = new TestDAO();
		PasoDAO pasoDAO = new PasoDAO();
		
		JSONObject json = new JSONObject();
		String idTest = req.getParameter("idTest");
		Test test = testDAO.getTest(Integer.parseInt(idTest));
		json.put("nombre", test.getNombre());
		json.put("descripcion", test.getDescripcion());
		json.put("intentos", test.getIntentos());
		List<Paso> listaPasos = pasoDAO.getPasos(Integer.parseInt(idTest));
		json.put("numPasos", listaPasos.size());
		JSONArray array = new JSONArray();
		for(Paso paso : listaPasos){
			JSONObject js = new JSONObject();
			js.put(String.valueOf(paso.getIdPaso()), paso.getNombre());
			array.put(js);
		}
		json.put("pasos", array);
		return json;
	}
	
	/**
	 * retorno un json con todos los test no asignados a un usuario
	 * @param req
	 * @return
	 */
	private JSONObject getListTestNotAssigned(HttpServletRequest req) {
		TestDAO testDAO = new TestDAO();
		RobotTestDAO robotTestDAO = new RobotTestDAO();
		
		
		JSONObject json = new JSONObject();
		String idRobot = req.getParameter("idRobot");
		HttpSession sesionOk = req.getSession();
		UserLogin usuarioLogin = (UserLogin)sesionOk.getAttribute("userLogin");
		List<Test> listTests = testDAO.getTestListByIdUser(usuarioLogin.getIdUser());
		
		List<RobotTest> listRobotTest = robotTestDAO.getListRobotTestByIdRobot(Integer.parseInt(idRobot));
		for(RobotTest robotTest : listRobotTest){
			Test tst = null;
			for(Test test : listTests){
				if(test.getIdTest() == robotTest.getIdTest()){
					tst = test;
					break;
				}
			}
			listTests.remove(tst);
		}
		for(Test test : listTests){
			JSONArray array = new JSONArray();
			array.put(test.getNombre());
			array.put(test.getDescripcion());
			String data = test.getDataAlta();
			data = data.substring(6, 8)+"/"+data.substring(4, 6)+"/"+data.substring(0, 4);
			array.put(data);
			json.put(String.valueOf(test.getIdTest()), array);
		}
		return json;
	}
	
	/**
	 * Retorna un json con todos los test asociados a un usuario
	 * @param req
	 * @return
	 */
	private JSONObject getListTest(HttpServletRequest req) {
		TestDAO testDAO = new TestDAO();
	
		JSONObject json = new JSONObject();
		HttpSession sesionOk = req.getSession();
		UserLogin usuarioLogin = (UserLogin)sesionOk.getAttribute("userLogin");
		List<Test> list = testDAO.getTestListByIdUser(usuarioLogin.getIdUser());
		for(Test test : list){
			JSONArray array = new JSONArray();
			array.put(test.getNombre());
			array.put(test.getDescripcion());
			String data = test.getDataAlta();
			data = data.substring(6, 8)+"/"+data.substring(4, 6)+"/"+data.substring(0, 4);
			array.put(data);
			json.put(String.valueOf(test.getIdTest()), array);
		}
		return json;
	}

	private boolean deleteTest(HttpServletRequest req) {
		TestDAO testDAO = new TestDAO();
		TestUsuarioDAO testUsuarioDAO = new TestUsuarioDAO();
		
		boolean rc=false;
		String[] arrayIdTest = req.getParameter("idTests").trim().split(",");
		rc = testDAO.deleteTest(arrayIdTest);
		if(rc){
			rc = testUsuarioDAO.deleteTestUsuario(arrayIdTest);
		}
		return rc;
	}

	private boolean saveTest(HttpServletRequest req) {
		TestUsuarioDAO testUsuarioDAO = new TestUsuarioDAO();
		TestDAO testDAO = new TestDAO();
		
		boolean rc=false;
		HttpSession sesionOk = req.getSession();
		UserLogin usuarioLogin = (UserLogin)sesionOk.getAttribute("userLogin");
		UploadTest.idCarpeta=0;
		String nombre = req.getParameter("nombre");
		String desc = req.getParameter("descripcion");
		String intentos = req.getParameter("intentos");
		String nombreTest = nombre;
		String dataAlta = getDataAlta();
		String nomPasos = req.getParameter("nomPasos");
		String[] arrayNomPasos = nomPasos.split("/");
		Test test = new Test(nombre,desc,dataAlta,nombreTest,Integer.parseInt(intentos));
		int idTest = testDAO.insertTest(test);
		if(idTest!=0){
			rc = savePasos(idTest,arrayNomPasos);
			
			TestUsuario testUsuario = new TestUsuario(usuarioLogin.getIdUser(),idTest);
			rc = testUsuarioDAO.insertTestUsuario(testUsuario);
			if(usuarioLogin.getIdUser() != IDUSER_ADMIN){
				testUsuario = new TestUsuario(IDUSER_ADMIN,idTest);
				rc = testUsuarioDAO.insertTestUsuario(testUsuario);
			}
		}
		UploadTest.idCarpeta=idTest;
		return rc;
	}
	
	private boolean savePasos(int idTest, String[] arrayNomPasos) {
		boolean rc=false;
		PasoDAO pasoDAO = new PasoDAO();
		//Los id del paso se genera mediante la sequencia 1,2,3.. en todos los casos
		//no corresponde al id de base de datos
		for(int i=0;i<arrayNomPasos.length;i++){
			Paso paso = new Paso((i+1),idTest,arrayNomPasos[i]);
			rc = pasoDAO.insertPaso(paso);
		}
		return rc;
	}

	private String getDataAlta(){
		String data = null;
		Calendar cal = Calendar.getInstance();
		int dia = cal.get(Calendar.DAY_OF_MONTH);
		int month = cal.get(Calendar.MONTH)+1;
		String dayString;
		String monthString;
		if(dia<10){
			dayString = "0"+dia;
		}else{
			dayString = String.valueOf(dia);
		}
		if(month<10){
			monthString = "0"+month;	
		}else{
			monthString = String.valueOf(month);
		}
		data = cal.get(Calendar.YEAR)+""+monthString+""+dayString+"0000";
		return data;
	}
}
