package com.servlets;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Iterator;
import java.util.List;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileItemFactory;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.json.JSONObject;

public class UploadTest extends HttpServlet {
	public static int idCarpeta=0;
	
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)throws ServletException, IOException {
		doPost(req, resp);
	}

	
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)throws ServletException, IOException {
		String uploadFolder = "C://Users//add//Desktop//resultado//"+idCarpeta+"";
		File carpeta = new File(uploadFolder);
		carpeta.mkdir();
		JSONObject json = new JSONObject();

		boolean isMultipartContent = ServletFileUpload.isMultipartContent(req);
		if (!isMultipartContent) {
			json.put("rc", "ko");
			return;
		}
		FileItemFactory factory = new DiskFileItemFactory();
		ServletFileUpload upload = new ServletFileUpload(factory);
		try {
			List<FileItem> fields = upload.parseRequest(req);
			Iterator<FileItem> it = fields.iterator();
			if (!it.hasNext()) {
				json.put("rc", "ko");
				return;
			}
			while (it.hasNext()) {
				FileItem fileItem = it.next();
				if (!fileItem.isFormField()) {
                    String fileName = new File(fileItem.getName()).getName();
                    String filePath = uploadFolder + File.separator + fileName;
                    File uploadedFile = new File(filePath);
                    try {
						fileItem.write(uploadedFile);
						json.put("rc", "ok");
					} catch (Exception e) {
						e.printStackTrace();
						json.put("rc", "ko");
					}
                }
			}
		} catch (FileUploadException e) {
			e.printStackTrace();
			json.put("rc", "ko");
		}
		PrintWriter out = resp.getWriter();
		out.print(json);
		out.flush();
		out.close();
	}
}
