package com.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.JSONArray;
import org.json.JSONObject;

import com.hibernate.dao.UsuarioDAO;
import com.hibernate.map.Usuario;

public class UsuarioServlet extends HttpServlet{
	
	private static final int SAVE_USER = 1;
	private static final int DELETE_USER = 2;
	private static final int GETLIST_USER = 3;
	private static final int GET_USEREDIT = 4;
	private static final int UPLOAD_USER = 5;
	UsuarioDAO userDAO = new UsuarioDAO();
	
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)throws ServletException, IOException {
		doPost(req, resp);
	}
	
	
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)throws ServletException, IOException {
		int operacion = Integer.parseInt(req.getParameter("operacion").trim().toString());
		JSONObject json = new JSONObject();
		switch(operacion){
		case SAVE_USER:
			json.put("rc", saveUser(req));
			break;
		case DELETE_USER:
			json.put("rc", deleteUsers(req));
			break;
		case GETLIST_USER:
			json = getListUsers();
			break;
		case GET_USEREDIT:
			json = getUserEdit(req);
			break;
		case UPLOAD_USER:
			json = uploadUser(req);
			break;
		default:
			break;
		}
		
		PrintWriter out = resp.getWriter();
		out.print(json);
		out.flush();
		out.close();
		
	}


	private JSONObject uploadUser(HttpServletRequest req) {
		JSONObject json = new JSONObject();
		String idUser= req.getParameter("idUser");
		String nombre = req.getParameter("login");
		String pass = req.getParameter("password");
		String alta = req.getParameter("alta");
		Usuario usuario = new Usuario(Integer.parseInt(idUser),nombre,pass,Integer.parseInt(alta));
		json.put("rc", userDAO.uploadUsuario(usuario));
		return json;
	}


	private JSONObject getUserEdit(HttpServletRequest req) {
		JSONObject json = new JSONObject();
		String idUsuario = req.getParameter("idUsuario");
		Usuario usuario = userDAO.getUsuario(Integer.parseInt(idUsuario));
		json.put("nombre", usuario.getLogin());
		json.put("password", usuario.getPassword());
		json.put("alta", usuario.getAlta());
		return json;
	}


	private JSONObject getListUsers() {
		JSONObject json = new JSONObject();
		List<Usuario> list = userDAO.getListUsers();
		for(Usuario usuario : list){
			JSONArray array = new JSONArray();
			array.put(usuario.getLogin());
			array.put(usuario.getAlta());
			json.put(String.valueOf(usuario.getIdUsuario()), array);
		}
		return json;
	}


	private boolean deleteUsers(HttpServletRequest req) {
		boolean rc=false;
		String[] arrayIdUser = req.getParameter("idUsuarios").trim().split(",");
		rc = userDAO.deleteUser(arrayIdUser);
		return rc;
	}


	private boolean saveUser(HttpServletRequest req) {
		boolean rc=false;
		String login = req.getParameter("login");
		String password = req.getParameter("password");
		String alta = req.getParameter("alta");
		Usuario user = new Usuario(login,password,Integer.parseInt(alta));
		rc = userDAO.insertUsuario(user);
		return rc;
	}
}
