package com.pfc.selenium.UI.listeners;

import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import com.pfc.selenium.UI.runnable.RunExecution;
import com.pfc.selenium.classes.Robot;
import com.pfc.selenium.agente.Agente;

/**
 * 
 * @author Xavier Font Erruz
 * @version 14/05/2014
 */
public class PlayEvent implements Listener {
	private Shell shell;
	private Display display;
	private Button playButton;
	private Button stopButton;
	private Robot robot;
	

	/**
	 * Constructor por parametros del objeto
	 * @param agentShell shell
	 * @param playButton boton play
	 * @param stopButton boton stop
	 * @param robot robot
	 */
	public PlayEvent(Shell agentShell, Button playButton, Button stopButton,Robot robot) {
		this.display = agentShell.getDisplay();
		this.shell = agentShell;
		this.playButton=playButton;
		this.stopButton=stopButton;
		this.robot = robot;
	}

	
	/**
	 * Manejador del evento clic sobre el botn play
	 */
	public void handleEvent(Event arg0) {
		Agente.log.info("Play pulsado");
		//desactivamos el botn play al estar ya en modo play, y activamos el botn stop
		setButtons();
		//creamos e iniciamos el thread de ejecucin de tests
		Thread thRun = new Thread(new RunExecution(robot));
		thRun.setName("ThreadRunTest");
		RunExecution.stopState = false;
		thRun.start();
		
		
	}

	/**
	 * funcin para inicializar los botones.
	 */
	private void setButtons() {
		Image playdisabled = new Image(display, getClass().getResourceAsStream("/images/playdisabled.png"));
		Image stopEnabled = new Image(display, getClass().getResourceAsStream("/images/stoplong.png"));
		playButton.setImage(playdisabled);
		stopButton.setImage(stopEnabled);
		shell.update();
		
	}

}
