package com.pfc.selenium.UI.listeners;

import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;


import com.pfc.selenium.agente.Agente;
import com.pfc.selenium.UI.runnable.RunExecution;
import com.pfc.selenium.UI.runnable.StopExecution;

/**
 * 
 * @author Xavier Font Erruz
 * @version 14/05/2014
 */
public class StopEvent implements Listener{

	private Shell shell;
	private Display display;
	private Button playButton;
	private Button stopButton;
	
	/**
	 * Constructor por parametros del objeto
	 * @param agentShell shell
	 * @param playButton boton play
	 * @param stopButton boton stop
	 */
	public StopEvent(Shell agentShell, Button playButton, Button stopButton) {
		this.display = agentShell.getDisplay();
		this.shell = agentShell;
		this.playButton=playButton;
		this.stopButton=stopButton;
	}

	/**
	 * Manejador del evento clic sobre el botn stop
	 */
	public void handleEvent(Event arg0) {
		Agente.log.info("stop pulsado");
		//desactivamos el botn stop y activamos el botn play
		setButtons();
		//creamos e iniciamos el thread de parada de ejecucin
		Thread thStop = new Thread(new StopExecution());
		RunExecution.stopState = true;
		thStop.start();
	}
	
	/**
	 * funcin para inicializar los botones.
	 */
	private void setButtons() {
		Image playEnabled = new Image(display, getClass().getResourceAsStream("/images/playlong.png"));
		Image stopDisabled = new Image(display, getClass().getResourceAsStream("/images/stopdisabled.png"));
		playButton.setImage(playEnabled);
		stopButton.setImage(stopDisabled);
		shell.update();
	}

}
