package com.pfc.selenium.agente;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;

/**
 * 
 * @author Xavier Font Erruz
 * @version 24/04/2014
 * 
 */
public class ClassLoaderCustom extends ClassLoader{

	
	/**
	 * Constructor con parametros de la classe
	 * @param parent Class padre
	 */
    public ClassLoaderCustom(ClassLoader parent) {
        super(parent);
    }

    
    /**
     * 
     * @param path path donde tenemos el fichero de test JUnit compilado que queremos cargar
     * @param fileName nombre del test JUnit compilado
     * @return Class objeto Class associado al test JUnit
     * @throws ClassNotFoundException 
     */
    public Class loadClass(String path,String fileName) throws ClassNotFoundException {
      
        try {
        	//formamos la URL (Uniform Resource Locator) con el path y el nombre del fichero
        	String url = "file:" + path;
        	//creamos un objeto URL 
            URL myUrl = new URL(url);
      
            //realizamos la conexin al objeto
            URLConnection connection = myUrl.openConnection();
            //"descargamos" el objeto URL
            InputStream input = connection.getInputStream();
            ByteArrayOutputStream buffer = new ByteArrayOutputStream();
            int data = input.read();

            //abrimos el objeto como si fuera un fichero de texto y lo copiamos localmente
            while(data != -1){
                buffer.write(data);
                data = input.read();
            }
            
            input.close();

            byte[] classData = buffer.toByteArray();

            //devolvemos el objeto Class
            return defineClass(fileName,
                  classData, 0, classData.length);

        } catch (MalformedURLException e) {
        	Agente.log.error(e.toString());
            e.printStackTrace();
        } catch (IOException e) {
        	Agente.log.error(e.toString());
            e.printStackTrace(); 
        }

        return null;
    }

}