package com.pfc.selenium.classes;

/**
 * 
 * @author Xavier Font Erruz
 * @version 23/04/2014
 */
public class Calendario {

	private int idCalendario;
	private String startDate;
	private String endDate;
	private int startHour;
	private int endHour;
	private int everyXMinutes;
	
	
	/**
	 * Constructor por parametros de la clase calendario
	 * @param idCalendario identificador del calendario
	 * @param startDate fecha inicial de la ejecucin
	 * @param endDate fecha final de la ejecucin
	 * @param startHour hora inicial de la ejecucin
	 * @param endHour hora final de la ejecucin
	 * @param everyXMinutes cada cuantos minutos se repetira la ejecucin
	 */
	public Calendario(int idCalendario, String startDate, String endDate,
			int startHour, int endHour, int everyXMinutes) {
		
		this.idCalendario = idCalendario;
		this.startDate = startDate;
		this.endDate = endDate;
		this.startHour = startHour;
		this.endHour = endHour;
		this.everyXMinutes = everyXMinutes;
	}

	/**
	 * Getter de idCalendario
	 * @return idCalendario identificador del calendario
	 */
	public int getIdCalendario() {
		return idCalendario;
	}
	
	/**
	 * Setter de idCalendario
	 * @param idCalendario identificador del calendario
	 */
	public void setIdCalendario(int idCalendario) {
		this.idCalendario = idCalendario;
	}
	
	/**
	 * Getter de startDate
	 * @return startDate fecha inicial de la ejecucin
	 */
	public String getStartDate() {
		return startDate;
	}

	/**
	 * Setter de startDate
	 * @param startDate fecha inicial de la ejecucin
	 */
	public void setStartDate(String startDate) {
		this.startDate = startDate;
	}

	/**
	 * Getter de endDate
	 * @return String fecha final de la ejecucin
	 */
	public String getEndDate() {
		return endDate;
	}

	/**
	 * setter de end date
	 * @param endDate fecha final de la ejecucin
	 */
	public void setEndDate(String endDate) {
		this.endDate = endDate;
	}

	/**
	 * getter de start hour
	 * @return int hora inicial de la ejecucin
	 */
	public int getStartHour() {
		return startHour;
	}

	/**
	 * setter de startHour
	 * @param startHour hora inicial de la ejecucin
	 */
	public void setStartHour(int startHour) {
		this.startHour = startHour;
	}

	/**
	 * getter de endHour
	 * @return int hora final de la ejecucin
	 */
	public int getEndHour() {
		return endHour;
	}

	/**
	 * setter de endHour
	 * @param endHour hora final de la ejecucin
	 */
	public void setEndHour(int endHour) {
		this.endHour = endHour;
	}

	/**
	 * getter
	 * @return int cada cuantos minutos se repetir la ejecucin del test
	 */
	public int getEveryXMinutes() {
		return everyXMinutes;
	}

	/**
	 * setter
	 * @param everyXMinutes cada cuantos minutos se repetir la ejecucin del test
	 */
	public void setEveryXMinutes(int everyXMinutes) {
		this.everyXMinutes = everyXMinutes;
	}
	
}
