package com.pfc.selenium.classes;

/**
 * 
 * @author Xavier Font Erruz
 * @version 06/05/2014
 */
public class Resultado {
	
	private int idResultado;
	private String fecha;
	private int idRobot;
	private int idTest;
	private int idPaso;
	private int idGrupTest;
	private double tiempoPaso;
	private int idError;
	private String pathError;
	private String errorMsg;
	private String harFile;
	
	
	/**
	 * constructor sin parametros
	 */
	public Resultado(){
		
	}
	
	/**
	 * Constructor con parametros
	 * @param idResultado identificador del resultado
	 * @param fecha fecha del resultado
	 * @param idRobot identificador del robot que ejecuto el test
	 * @param idTest identificador del test
	 * @param idPaso identificador del paso
	 * @param idGrupTest identificador del grupo de test
	 * @param tiempoPaso tiempo del paso
	 * @param idError identificador del error (0 si ok, <> 0 si error)
	 * @param pathError path con la captura de pantalla, null en caso de idError == 0
	 * @param errorMsg texto del error, null en caso de idError ==0
	 * @param harFile nombre del fichero HAR
	 */
	
	public Resultado(int idResultado, String fecha, int idRobot, int idTest,
			int idPaso, int idGrupTest, double tiempoPaso, int idError, String pathError,String errorMsg,String harFile) {
		
		this.idResultado = idResultado;
		this.fecha = fecha;
		this.idRobot = idRobot;
		this.idTest = idTest;
		this.idPaso = idPaso;
		this.idGrupTest = idGrupTest;
		this.tiempoPaso = tiempoPaso;
		this.idError = idError;
		this.pathError = pathError;
		this.errorMsg = errorMsg;
		this.harFile = harFile;
	}

	/**
	 * get idResultado
	 * @return int
	 */
	public int getIdResultado() {
		return idResultado;
	}

	/**
	 * set idResultado
	 * @param idResultado identificador del resultado
	 */
	public void setIdResultado(int idResultado) {
		this.idResultado = idResultado;
	}

	/**
	 * get Fecha del resultado
	 * @return String
	 */
	public String getFecha() {
		return fecha;
	}

	/**
	 * set fecha
	 * @param fecha fecha de ejecucin del paso
	 */
	public void setFecha(String fecha) {
		this.fecha = fecha;
	}

	/**
	 * get idRobot
	 * @return int
	 */
	public int getIdRobot() {
		return idRobot;
	}

	/**
	 * 
	 * @param idRobot
	 */
	public void setIdRobot(int idRobot) {
		this.idRobot = idRobot;
	}

	public int getIdTest() {
		return idTest;
	}

	public void setIdTest(int idTest) {
		this.idTest = idTest;
	}

	public int getIdPaso() {
		return idPaso;
	}

	public void setIdPaso(int idPaso) {
		this.idPaso = idPaso;
	}

	public int getIdGrupTest() {
		return idGrupTest;
	}

	public void setIdGrupTest(int idGrupTest) {
		this.idGrupTest = idGrupTest;
	}

	public double getTiempoPaso() {
		return tiempoPaso;
	}

	public void setTiempoPaso(double tiempoPaso) {
		this.tiempoPaso = tiempoPaso;
	}

	public String getPathError() {
		return pathError;
	}

	public void setPathError(String pathError) {
		this.pathError = pathError;
	}

	public int getIdError() {
		return idError;
	}

	public void setIdError(int idError) {
		this.idError = idError;
	}

	public String getErrorMsg() {
		return errorMsg;
	}

	public void setErrorMsg(String errorMsg) {
		this.errorMsg = errorMsg;
	}

	public String getHarFile() {
		return harFile;
	}

	public void setHarFile(String harFile) {
		this.harFile = harFile;
	}
	
	
}
