package com.pfc.selenium.classes;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.GregorianCalendar;

import com.pfc.selenium.classes.Calendario;


/**
 * 
 * @author Xavier Font Erruz
 * @version 23/04/2014
 */
public class Test {

	
	private int id;
	private String nom;
	private String descripcio;
	private String dataAlta;
	private String pathCircuito;
	@SuppressWarnings("rawtypes")
	private java.lang.Class circuito;
	private ArrayList<Calendario> calendarios;
	private Calendar lastExecution;
	private Calendar nextExecution;
	private int lastResult;//0 --> ok , 1 --> error , 2 --> not executed
	private String browser;
	private boolean estado;
	
	
	/**
	 * Constructor por parametros
	 * @param id identificador del test
	 * @param nom nombre del test
	 * @param descripcio descripcin del test
	 * @param dataAlta fecha de alta del test
	 * @param pathCircuito ruta al fichero JUnit del test
	 * @param circuito fichero JUnit del test
	 * @param browser tipo de navegador
	 */
	public Test(int id, String nom, String descripcio, String dataAlta, String pathCircuito, Class circuito,String browser) {
		this.id = id;
		this.nom = nom;
		this.descripcio = descripcio;
		this.dataAlta = dataAlta;
		this.pathCircuito = pathCircuito;
		this.circuito = circuito;
		this.lastExecution =  null;
		this.nextExecution = null;
		this.lastResult = 2;
		this.browser = browser;
		this.estado = false;
	}
	
	/**
	 * Constructor por parametros
	 * @param id identificador del test
	 * @param nom nombre del test
	 * @param descripcio descripcin del test
	 * @param dataAlta fecha de alta del test
	 * @param pathCircuito ruta al fichero JUnit del test
	 * @param browser tipo de navegador
	 */
	public Test(int id, String nom, String descripcio, String dataAlta, String pathCircuito,String browser) {
		
		this.id = id;
		this.nom = nom;
		this.descripcio = descripcio;
		this.dataAlta = dataAlta;
		this.pathCircuito = pathCircuito;
		this.lastExecution =  null;
		this.nextExecution = null;
		this.lastResult = 2;
		this.browser = browser;
		this.estado = false;
	}
	
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	public String getNom() {
		return nom;
	}
	public void setNom(String nom) {
		this.nom = nom;
	}
	public String getDescripcio() {
		return descripcio;
	}
	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}
	@SuppressWarnings("rawtypes")
	public java.lang.Class getCircuito() {
		return circuito;
	}
	@SuppressWarnings("rawtypes")
	public void setCircuito( Class circuito) {
		this.circuito = circuito;
	}

	public String getDataAlta() {
		return dataAlta;
	}

	public void setDataAlta(String dataAlta) {
		this.dataAlta = dataAlta;
	}

	public String getPathCircuito() {
		return pathCircuito;
	}

	public void setPathCircuito(String pathCircuito) {
		this.pathCircuito = pathCircuito;
	}

	public ArrayList<Calendario> getCalendarios() {
		return calendarios;
	}

	public void setCalendarios(ArrayList<Calendario> calendarios) {
		this.calendarios = calendarios;
	}


	public Calendar getLastExecution() {
		return lastExecution;
	}


	public void setLastExecution(Calendar lastExecution) {
		this.lastExecution = lastExecution;
	}


	public Calendar getNextExecution() {
		return nextExecution;
	}


	public void setNextExecution(Calendar nextExecution) {
		this.nextExecution = nextExecution;
	}


	public int getLastResult() {
		return lastResult;
	}


	public void setLastResult(int lastResult) {
		this.lastResult = lastResult;
	}


	public String getBrowser() {
		return browser;
	}


	public void setBrowser(String browser) {
		this.browser = browser;
	}


	public boolean getEstado() {
		return estado;
	}


	public void setEstado(boolean estado) {
		this.estado = estado;
	}	
	

}
