package com.pfc.selenium.testRunner;

import java.io.File;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.List;

import org.junit.runner.Result;
import org.junit.runner.notification.Failure;

/**
 * 
 * @author Xavier Font Erruz
 * @version 02/04/2014
 */
public class ResultCustom{
	
	private ArrayList<Double> tempsPas;
	private Result res;
	private int errorCount;
	private List<Failure> errorList;
	private File screnCapture;
	private ArrayList<String> tempsExePas;
	
/**
 * 	Constrocutor por parametros de la clase resultado customizado
 * @param res objeto resultado
 * @param tempsPas arrayList con los tiempos de los pasos
 * @param screenCapture fichero con la captura de pantalla. Sera null en caso que el circuito se ejecutar correctamente
 * @param tempsExePas arrayList con la hora en la que se ha ejecutado cada paso.
 */
	public ResultCustom(Result res, ArrayList<Double> tempsPas,File screenCapture,ArrayList<String> tempsExePas){
		Calendar now = GregorianCalendar.getInstance();
		DateFormat df = new SimpleDateFormat("YYYYMMddHHmmss");
		String date = df.format(now.getTime());
		
		this.res=res;
		//caso en el que ha habido error y este ha sido en el paso 1. En este caso no tendremos valor de tiempo, por lo que lo forzamos nosotros a 0.
		if (tempsPas.size()==0){
			ArrayList<Double> tp = new ArrayList<Double>();
			ArrayList<String> tep = new ArrayList<String>();
			tp.add(0.0);
			tep.add(date);
			this.tempsExePas = tep;
			this.tempsPas = tp;
		}else{
			//En caso que el circuito ha ido bien o el error ha sido despues del paso 1 guardamos los tiempos.
			this.tempsPas=tempsPas;
			this.tempsExePas = tempsExePas;
		}
		
		this.errorCount = res.getFailureCount();
		this.errorList = res.getFailures();
		this.screnCapture = screenCapture;
	}

	
	public ArrayList<Double> getTempsPas() {
		return tempsPas;
	}

	public void setTempsPas(ArrayList<Double> tempsPas) {
		this.tempsPas = tempsPas;
	}

	public void setRes(Result res) {
		this.res = res;
	}
	
	public int getErrorCount(){
		return errorCount;
	}
	
	public List<Failure> getErrorList(){
		return errorList;
	}

	public File getScrenCapture() {
		return screnCapture;
	}

	public void setScrenCapture(File screnCapture) {
		this.screnCapture = screnCapture;
	}


	public ArrayList<String> getTempsExePas() {
		return tempsExePas;
	}


	public void setTempsExePas(ArrayList<String> tempsExePas) {
		this.tempsExePas = tempsExePas;
	}
	

}
