package com.pfc.meu.webservice.hibernate.dao;

import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.Transaction;

/**
 * Clase para realizar la conexin a la BBDD
 * @author NoItAmI
 * @version 224/04/2014
 */
public class Connection {
	protected Session sesion;
	protected Transaction tx;
	
	/**
	 * Funcin para iniciar la connexin con la BBDD
	 * @throws HibernateException excepcin de acceso a la BBDD
	 */
	protected void iniciaOperacion() throws HibernateException{
		//abrimos la sesion
	    sesion = HibernateUtil.getSessionFactory().openSession();
	    //empezamos la transaccion
	    tx = sesion.beginTransaction();
	}
	
	/**
	 * Funcin para manejar las excepciones
	 * @param he excepcion
	 * @throws HibernateException excepcin de acceso a la capa de datos
	 */
	protected void manejaExcepcion(HibernateException he) throws HibernateException{
	    tx.rollback();
	    throw new HibernateException("Ocurri un error en la capa de acceso a datos", he);
	}
}
