package com.pfc.meu.webservice.hibernate.dao;

import org.hibernate.HibernateException;

import com.pfc.meu.webservice.hibernate.mappings.Resultado;
/**
 * Objeto de acceso a datos de Resultado
 * @author NoItAmI
 * @version 06/05/2014
 */
public class ResultadoDAO extends Connection {
	
	/**
	 * Funcin para guardar un resultado en la BBDD
	 * @param resultado objeto resultado
	 * @return int
	 */
	public int	saveResultado(Resultado resultado){
		int id = 0;
		
		try { 
	         iniciaOperacion(); 
	         id = (Integer)sesion.save(resultado); 
	         tx.commit(); 
	     }catch(HibernateException he) { 
	         manejaExcepcion(he);
	         throw he; 
	     }finally { 
	         sesion.close(); 
	     }  
	     return id; 
	}
	

}
