package com.pfc.meu.webservice.hibernate.dao;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.criterion.Restrictions;

import com.pfc.meu.webservice.hibernate.mappings.Robot;

/**
 * 
 * @author NoItAmI
 * @version 18/04/2014
 */
public class RobotDAO extends Connection{

	
//	public int	saveRobot(Robot robot){
//		int id = 0;
//		
//		try { 
//	         iniciaOperacion(); 
//	         id = (Integer)sesion.save(robot); 
//	         tx.commit(); 
//	     }catch(HibernateException he) { 
//	         manejaExcepcion(he);
//	         throw he; 
//	     }finally { 
//	         sesion.close(); 
//	     }  
//	     return id; 
//	}
//	
//	public void updateRobot(Robot robot) throws HibernateException { 
//	     try{ 
//	         iniciaOperacion(); 
//	         sesion.update(robot); 
//	         tx.commit(); 
//	     }catch (HibernateException he) { 
//	         manejaExcepcion(he); 
//	         throw he; 
//	     }finally { 
//	         sesion.close(); 
//	     } 
//	 }
//	
//	 public void deleteRobot(Robot robot) throws HibernateException { 
//	     try { 
//	         iniciaOperacion(); 
//	         sesion.delete(robot); 
//	         tx.commit(); 
//	     } catch (HibernateException he){ 
//	         manejaExcepcion(he); 
//	         throw he; 
//	     }finally { 
//	         sesion.close(); 
//	     } 
//	 }
//	 

	 
	/**
	 * Funcin para obtener un robot a partir de su ID
	 * @param idRobot identificador del robot
	 * @return Robot
	 * @throws HibernateException
	 */
	 public Robot getRobotByID(int idRobot) throws HibernateException{ 
		  Robot rbt = null;  
		     try { 
		         iniciaOperacion(); 
		         rbt = (Robot) sesion.get(Robot.class, idRobot); 
		     } finally { 
		         sesion.close(); 
		     }  
		     return rbt; 
		 }
	 
	 /**
	  * Funcin para obtener un objeto robot a partir de su nombre
	  * @param robotName nombre del robot
	  * @return List<Robot>
	  * @throws HibernateException
	  */
	 public List<Robot> getRobotByName(String robotName) throws HibernateException{
		 List<Robot> listaRobot = null;  
		  
		     try { 
		         iniciaOperacion();
		         Criteria criteria = sesion.createCriteria(Robot.class);
		         criteria.add(Restrictions.eq("nombre", robotName));
		         listaRobot = criteria.list();
		     }catch(HibernateException he){
		    	 manejaExcepcion(he); 
			     throw he; 
		     }finally { 
		         sesion.close(); 
		     }  
		     return listaRobot; 
		 }
	 
	 /**
	  * Funcin para obtener un listado de todos los robots
	  * @return List<Robot>
	  * @throws HibernateException
	  */
	 public List<Robot> getAllRobots() throws HibernateException { 
	     List<Robot> robotList = null;  
	     try { 
	         iniciaOperacion(); 
	         robotList = sesion.createQuery("from Robot").list(); 
	     }finally { 
	         sesion.close(); 
	     }  

	      return robotList; 
	 }
}
