package com.pfc.meu.webservice.hibernate.dao;

import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.criterion.Disjunction;
import org.hibernate.criterion.Restrictions;
import com.pfc.meu.webservice.hibernate.mappings.RobotTest;
import com.pfc.meu.webservice.hibernate.mappings.Test;


/**
 * 
 * @author NoItAmI
 * @version 18/04/2014
 */
public class TestDAO extends Connection {
	
	 
//	 public int saveTest(Test test){ 
//	     int id = 0;  
//	     try { 
//	         iniciaOperacion(); 
//	         id = (Integer)sesion.save(test); 
//	         tx.commit(); 
//	     }catch(HibernateException he) { 
//	         manejaExcepcion(he);
//	         throw he; 
//	     }finally { 
//	         sesion.close(); 
//	     }  
//	     return id; 
//	 }
//	 
//	 public void updateTest(Test test) throws HibernateException { 
//	     try{ 
//	         iniciaOperacion(); 
//	         sesion.update(test); 
//	         tx.commit(); 
//	     }catch (HibernateException he) { 
//	         manejaExcepcion(he); 
//	         throw he; 
//	     }finally { 
//	         sesion.close(); 
//	     } 
//	 }
//	 
//	 public void deleteTest(Test test) throws HibernateException { 
//	     try { 
//	         iniciaOperacion(); 
//	         sesion.delete(test); 
//	         tx.commit(); 
//	     } catch (HibernateException he){ 
//	         manejaExcepcion(he); 
//	         throw he; 
//	     }finally { 
//	         sesion.close(); 
//	     } 
//	 }
//	 
	
	/**
	 * Funcin para obtener todos los datos de un test a partir de su identificador nico
	 * @param idTest identificador nico del test
	 * @return Test
	 * @throws HibernateException
	 */
	 public Test getTestById(int idTest) throws HibernateException{ 
		 Test tst = null;  
	     try { 
	         iniciaOperacion(); 
	         tst = (Test) sesion.get(Test.class, idTest); 
	     } finally { 
	         sesion.close(); 
	     }  
	     return tst; 
	 }
	 
	 /**
	  * Funcin para obtener todos los tests associados a un robot a partir del identificador nico del robot
	  * @param idRobot identificador nico del robot
	  * @return List<Test>
	  * @throws HibernateException
	  */
	 public List<Test> getTestByIdRobot(int idRobot) throws HibernateException{ 
		  List<Test> tstList = null;
		     try { 
		    	 
		         iniciaOperacion();
		         Criteria criteria2 = sesion.createCriteria(Test.class);
		         Criteria criteria = sesion.createCriteria(RobotTest.class);
		         criteria.add(Restrictions.eq("idRobot",idRobot));
		         List<RobotTest> rbtstList = criteria.list();
		         Disjunction disj =Restrictions.disjunction();
		         
		         for (RobotTest robottest : rbtstList){
		        	 disj.add(Restrictions.eq("idTest", robottest.getIdTest()));	 
		         }
		         criteria2.add(disj);
		         tstList = criteria2.list();
		     }catch(HibernateException he){
		    	 manejaExcepcion(he); 
			     throw he; 
		     } finally { 
		         sesion.close(); 
		     }  
		     return tstList; 
		 }
	 
	 
	 /**
	  * Funcin para obtener todos los tests almacenados en la BBDD
	  * @return List<Test>
	  * @throws HibernateException
	  */
	 public List<Test> getAllTests() throws HibernateException { 
	     List<Test> listaTelefons = null;  
	     try { 
	         iniciaOperacion(); 
	         listaTelefons = sesion.createQuery("from test").list(); 
	     }finally { 
	         sesion.close(); 
	     }  

	      return listaTelefons; 
	 }
}
