package com.pfc.meu.webservice.hibernate.mappings;

import java.io.Serializable;

/**
 * 
 * @author NoItAmI
 * @version 23/04/2014
 */
public class Calendario implements Serializable {

	
	private int idCalendario;
	private String startDate;
	private String endDate;
	private int startHour;
	private int endHour;
	private int everyXMinutes;
	
	
	/**
	 * Constructor, necesario por hibernate al instanciar el objeto
	 */
	public Calendario(){
		
	}
	
	/**
	 * Constructor por parametros
	 * @param idCalendario identificador del calendario
	 * @param startDate fecha inicial de ejecucin
	 * @param endDate fecha final de ejecucin
	 * @param startHour hora inicial de ejecucin
	 * @param endHour hora final de ejecucin
	 * @param everyXMinutes minutos cada cuanto se repetira la ejecucin
	 */
	
	public Calendario(int idCalendario, String startDate, String endDate,
			int startHour, int endHour, int everyXMinutes) {	
		this.idCalendario = idCalendario;
		this.startDate = startDate;
		this.endDate = endDate;
		this.startHour = startHour;
		this.endHour = endHour;
		this.everyXMinutes = everyXMinutes;
	}

	public int getIdCalendario() {
		return idCalendario;
	}

	public void setIdCalendario(int idCalendario) {
		this.idCalendario = idCalendario;
	}

	public String getStartDate() {
		return startDate;
	}

	public void setStartDate(String startDate) {
		this.startDate = startDate;
	}

	public String getEndDate() {
		return endDate;
	}

	public void setEndDate(String endDate) {
		this.endDate = endDate;
	}

	public int getStartHour() {
		return startHour;
	}

	public void setStartHour(int startHour) {
		this.startHour = startHour;
	}

	public int getEndHour() {
		return endHour;
	}

	public void setEndHour(int endHour) {
		this.endHour = endHour;
	}

	public int getEveryXMinutes() {
		return everyXMinutes;
	}

	public void setEveryXMinutes(int everyXMinutes) {
		this.everyXMinutes = everyXMinutes;
	}
	
	
	
	
}
